#include "cdf.h"
#include "stack-c.h"
/*
 * Author 
 * S. Steer , Copyright INRIA, Marsh 2006
 */

/* Calculate the element offset for a CDF array of Ndims dimensions, 
 * where dims is the list of dimension sizes and x is the set of indices 
 * for each dimension. majority is either COLUMN_MAJOR or ROW_MAJOR 
 * Note: first dimension here is the record number, which we treat 
 * as a special case 
 */
int CDF_Index(int *x,int *dims,int Ndims,long majority)
{
  int index;
  int multiplier;
  int i;
  int record_step;

  /* How many elements are there in one record? */
  record_step=1; for (i=Ndims-1; i>0; i--) record_step=record_step*dims[i];

  switch (majority) {

  case COLUMN_MAJOR:
    /* Ndims dimension changes most slowly */
    /* First dimension (record number) is special case */
    multiplier=1;
    
    /* First dimension changes most slowly */
    /* First dimension (record number) is special case */
    multiplier=1;
    index=x[0]*record_step;
    for (i=Ndims-1; i>=1; i--) {
      index+=x[i]*multiplier;
      multiplier=multiplier*dims[i];
    }
    break;
  default:
    Scierror(9999,"cdfread (CDF_Index): Unknown majority");
  }

  return index;

}
