#include "cdf.h"
#include "stack-c.h"
/*
 * Author 
 * S. Steer , Copyright INRIA, Marsh 2006
 */


/* 
 * Calculate the Scilab element offset for an array of Ndims dimensions, 
 * where dims is the list of dimension sizes and x is the set of indices 
 * for each dimension. majority is either COLUMN_MAJOR or ROW_MAJOR 
 */
int Scilab_Index(int *x,int *dims,int Ndims,long majority)
{
  int index;
  int multiplier;
  int i;
  switch (majority) {

  case ROW_MAJOR:
    /* Ndims dimension changes most slowly */
    /* First dimension (record number) is special case */
    multiplier=1;
    index=0;
    for (i=0; i<Ndims; i++) {
      index+=x[i]*multiplier;
      multiplier=multiplier*dims[i];
    }
    break;

  case COLUMN_MAJOR:
    /* First dimension changes most slowly */
    /* First dimension (record number) is special case */
    multiplier=1;
    index=0;
    for (i=Ndims-1; i>=0; i--) {
      index+=x[i]*multiplier;
      multiplier=multiplier*dims[i];
    }
    break;

  default:
    Scierror(999,"cdfread : Unknown majority");

  }
  return index;
}
