/*
 * Reference:
 * CDF C Reference Manual, version 3.1 January 2006 Space Physics Data Facility NASA 
 * Author 
 * S. Steer , Copyright INRIA, Marsh 2006
 * inspired of cdfread.c, Tim Horbury  1999, Astronomy Unit, Queen Mary and Westfield College, London
 */

#include "cdf.h"
#include "stack-c.h"

int cdfstatus(CDFstatus status)
{
 char cdf_message[CDF_ERRTEXT_LEN+1];

 if (status<CDF_WARN)
  {
   CDFerror(status,cdf_message);
   Scierror(999,cdf_message);
   return 0;
  }

 if (status<CDF_OK)
  {
   CDFerror(status,cdf_message);
   sciprint("CDF library warning: %s\n",cdf_message);
   return 1;
  }
   return 1;
}
